//! \verbatim
//! ###########################################################################
//! # ASPECT: A spectra clustering tool for exploration of large spectral surveys - Stage I
//! #
//! # Copyright (c) 2009 Aick in der Au
//! # All rights reserved.
//! ###########################################################################
//!
//!      created by : Aick in der Au <aick.inderau@gmail.com>
//!      created on : 1/19/2009
//! additional docs : none
//!  responsibility : 1. Aick in der Au
//!                   2. 
//! \endverbatim
//!
//! \file  keycodes.h

#define KB_ESCAPE          0x01
#define KB_1               0x02
#define KB_2               0x03
#define KB_3               0x04
#define KB_4               0x05
#define KB_5               0x06
#define KB_6               0x07
#define KB_7               0x08
#define KB_8               0x09
#define KB_9               0x0A
#define KB_0               0x0B
#define KB_MINUS           0x0C    /* - on main keyboard */
#define KB_EQUALS          0x0D
#define KB_BACK            0x0E    /* backspace */
#define KB_TAB             0x0F
#define KB_Q               0x10
#define KB_W               0x11
#define KB_E               0x12
#define KB_R               0x13
#define KB_T               0x14
#define KB_Y               0x15
#define KB_U               0x16
#define KB_I               0x17
#define KB_O               0x18
#define KB_P               0x19
#define KB_LBRACKET        0x1A
#define KB_RBRACKET        0x1B
#define KB_RETURN          0x1C    /* Enter on main keyboard */
#define KB_LCONTROL        0x1D
#define KB_A               0x1E
#define KB_S               0x1F
#define KB_D               0x20
#define KB_F               0x21
#define KB_G               0x22
#define KB_H               0x23
#define KB_J               0x24
#define KB_K               0x25
#define KB_L               0x26
#define KB_SEMICOLON       0x27
#define KB_APOSTROPHE      0x28
#define KB_GRAVE           0x29    /* accent grave */
#define KB_LSHIFT          0x2A
#define KB_BACKSLASH       0x2B
#define KB_Z               0x2C
#define KB_X               0x2D
#define KB_C               0x2E
#define KB_V               0x2F
#define KB_B               0x30
#define KB_N               0x31
#define KB_M               0x32
#define KB_COMMA           0x33
#define KB_PERIOD          0x34    /* . on main keyboard */
#define KB_SLASH           0x35    /* / on main keyboard */
#define KB_RSHIFT          0x36
#define KB_MULTIPLY        0x37    /* * on numeric keypad */
#define KB_LMENU           0x38    /* left Alt */
#define KB_SPACE           0x39
#define KB_CAPITAL         0x3A
#define KB_F1              0x3B
#define KB_F2              0x3C
#define KB_F3              0x3D
#define KB_F4              0x3E
#define KB_F5              0x3F
#define KB_F6              0x40
#define KB_F7              0x41
#define KB_F8              0x42
#define KB_F9              0x43
#define KB_F10             0x44
#define KB_NUMLOCK         0x45
#define KB_SCROLL          0x46    /* Scroll Lock */
#define KB_NUMPAD7         0x47
#define KB_NUMPAD8         0x48
#define KB_NUMPAD9         0x49
#define KB_SUBTRACT        0x4A    /* - on numeric keypad */
#define KB_NUMPAD4         0x4B
#define KB_NUMPAD5         0x4C
#define KB_NUMPAD6         0x4D
#define KB_ADD             0x4E    /* + on numeric keypad */
#define KB_NUMPAD1         0x4F
#define KB_NUMPAD2         0x50
#define KB_NUMPAD3         0x51
#define KB_NUMPAD0         0x52
#define KB_DECIMAL         0x53    /* . on numeric keypad */
#define KB_OEM_102         0x56    /* < > | on UK/Germany keyboards */
#define KB_F11             0x57
#define KB_F12             0x58
#define KB_NUMPADENTER     0x9C    /* Enter on numeric keypad */
#define KB_NUMPADCOMMA     0xB3    /* , on numeric keypad (NEC PC98) */
#define KB_DIVIDE          0xB5    /* / on numeric keypad */
#define KB_RMENU           0xB8    /* right Alt */
#define KB_PAUSE           0xC5    /* Pause */
#define KB_HOME            0xC7    /* Home on arrow keypad */
#define KB_UP              0xC8    /* UpArrow on arrow keypad */
#define KB_PRIOR           0xC9    /* PgUp on arrow keypad */
#define KB_LEFT            0xCB    /* LeftArrow on arrow keypad */
#define KB_RIGHT           0xCD    /* RightArrow on arrow keypad */
#define KB_END             0xCF    /* End on arrow keypad */
#define KB_DOWN            0xD0    /* DownArrow on arrow keypad */
#define KB_NEXT            0xD1    /* PgDn on arrow keypad */
#define KB_INSERT          0xD2    /* Insert on arrow keypad */
#define KB_DELETE          0xD3    /* Delete on arrow keypad */
#define KB_LWIN            0xDB    /* Left Windows key */
#define KB_RWIN            0xDC    /* Right Windows key */
#define KB_APPS            0xDD    /* AppMenu key */

// MOUSE BUTTONS
#define MBB_LEFT		   0x100
#define MBB_RIGHT		   0x101




